# std::basic_istringstream< _CharT, _Traits, _Alloc > Class Template Reference

Controlling input for std::string. More...

Inheritance diagram for std::basic_istringstream< _CharT, _Traits, _Alloc >:

[legend]
Collaboration diagram for std::basic_istringstream< _CharT, _Traits, _Alloc >:

[legend]
List of all members.

## Public Types

typedef _CharT | char_type
typedef _Traits | traits_type
typedef traits_type::int_type | int_type
typedef traits_type::pos_type | pos_type
typedef traits_type::off_type | off_type
typedef _Ios_Fmtflags | fmtflags
| This is a bitmask type.
typedef _Ios_Iostate | iostate
| This is a bitmask type.
typedef _Ios_Openmode | openmode
| This is a bitmask type.
typedef _Ios_Seekdir | seekdir
| This is an enumerated type.
typedef void(* | event_callback )(event, ios_base &, int)
enum | event

## Public Member Functions

| basic_istringstream (ios_base::openmode __mode=ios_base::in)
| Default constructor starts with an empty string buffer.
| basic_istringstream (const __string_type &__str, ios_base::openmode __mode=ios_base::in)
| Starts with an existing string buffer.
| ~basic_istringstream ()
| The destructor does nothing.
__stringbuf_type * | rdbuf () const
| Accessing the underlying buffer.
__string_type | str () const
| Copying out the string buffer.
void | str (const __string_type &__s)
| Setting a new buffer.
streamsize | gcount () const
| Character counting.
iostate | rdstate () const
| Returns the error state of the stream buffer.
void | clear (iostate __state=goodbit)
| [Re]sets the error state.
void | setstate (iostate __state)
| Sets additional flags in the error state.
bool | good () const
| Fast error checking.
bool | eof () const
| Fast error checking.
bool | fail () const
| Fast error checking.
bool | bad () const
| Fast error checking.
iostate | exceptions () const
| Throwing exceptions on errors.
void | exceptions (iostate __except)
| Throwing exceptions on errors.
basic_ostream< _CharT, _Traits > * | tie () const
| Fetches the current tied stream.
basic_ostream< _CharT, _Traits > * | tie (basic_ostream< _CharT, _Traits > *__tiestr)
| Ties this stream to an output stream.
basic_streambuf< _CharT, _Traits > * | rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
| Changing the underlying buffer.
basic_ios & | copyfmt (const basic_ios &__rhs)
char_type | fill () const
| Retreives the "empty" character.
char_type | fill (char_type __ch)
| Sets a new "empty" character.
locale | imbue (const locale &__loc)
| Moves to a new locale.
char | narrow (char_type __c, char __dfault) const
| Squeezes characters.
char_type | widen (char __c) const
| Widens characters.
void | register_callback (event_callback __fn, int __index)
fmtflags | flags () const
| Access to format flags.
fmtflags | flags (fmtflags __fmtfl)
| Setting new format flags all at once.
fmtflags | setf (fmtflags __fmtfl)
| Setting new format flags.
fmtflags | setf (fmtflags __fmtfl, fmtflags __mask)
| Setting new format flags.
void | unsetf (fmtflags __mask)
| Clearing format flags.
streamsize | precision () const
| Flags access.
streamsize | precision (streamsize __prec)
| Changing flags.
streamsize | width () const
| Flags access.
streamsize | width (streamsize __wide)
| Changing flags.
locale | getloc () const
| Locale access.
long & | iword (int __ix)
void *& | pword (int __ix)
__istream_type & | operator>> (__istream_type &(*__pf)(__istream_type &))
| Interface for manipulators.
__istream_type & | operator>> (__ios_type &(*__pf)(__ios_type &))
| Interface for manipulators.
__istream_type & | operator>> (ios_base &(*__pf)(ios_base &))
| Interface for manipulators.
Arithmetic Extractors

All the `operator>>` functions (aka formatted input functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to false. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

__istream_type & | operator>> (bool &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (short &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned short &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (int &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned int &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (long &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned long &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (long long &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned long long &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (float &__f)
| Basic arithmetic extractors.
__istream_type & | operator>> (double &__f)
| Basic arithmetic extractors.
__istream_type & | operator>> (long double &__f)
| Basic arithmetic extractors.
__istream_type & | operator>> (void *&__p)
| Basic arithmetic extractors.
__istream_type & | operator>> (__streambuf_type *__sb)
| Extracting into another streambuf.
Unformatted Input Functions

All the unformatted input functions have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to true. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

The number of characters extracted is stored for later retrieval by gcount().

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

int_type | get ()
| Simple extraction.
__istream_type & | get (char_type &__c)
| Simple extraction.
__istream_type & | get (char_type *__s, streamsize __n, char_type __delim)
| Simple multiple-character extraction.
__istream_type & | get (char_type *__s, streamsize __n)
| Simple multiple-character extraction.
__istream_type & | get (__streambuf_type &__sb, char_type __delim)
| Extraction into another streambuf.
__istream_type & | get (__streambuf_type &__sb)
| Extraction into another streambuf.
__istream_type & | getline (char_type *__s, streamsize __n, char_type __delim)
| String extraction.
__istream_type & | getline (char_type *__s, streamsize __n)
| String extraction.
__istream_type & | ignore (streamsize __n=1, int_type __delim=traits_type::eof())
| Discarding characters.
int_type | peek ()
| Looking ahead in the stream.
__istream_type & | read (char_type *__s, streamsize __n)
| Extraction without delimiters.
streamsize | readsome (char_type *__s, streamsize __n)
| Extraction until the buffer is exhausted, but no more.
__istream_type & | putback (char_type __c)
| Unextracting a single character.
__istream_type & | unget ()
| Unextracting the previous character.
int | sync ()
| Synchronizing the stream buffer.
pos_type | tellg ()
| Getting the current read position.
__istream_type & | seekg (pos_type)
| Changing the current read position.
__istream_type & | seekg (off_type, ios_base::seekdir)
| Changing the current read position.
| operator void * () const
| The quick-and-easy status check.
bool | operator! () const
| The quick-and-easy status check.

## Static Public Member Functions

bool | sync_with_stdio (bool __sync=true)
| Interaction with the standard C I/O objects.
int | xalloc () throw ()

## Static Public Attributes

const fmtflags | boolalpha
| Insert/extract `bool` in alphabetic rather than numeric format.
const fmtflags | dec
| Converts integer input or generates integer output in decimal base.
const fmtflags | fixed
| Generate floating-point output in fixed-point notation.
const fmtflags | hex
| Converts integer input or generates integer output in hexadecimal base.
const fmtflags | internal
| Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated.
const fmtflags | left
| Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.).
const fmtflags | oct
| Converts integer input or generates integer output in octal base.
const fmtflags | right
| Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.).
const fmtflags | scientific
| Generates floating-point output in scientific notation.
const fmtflags | showbase
| Generates a prefix indicating the numeric base of generated integer output.
const fmtflags | showpoint
| Generates a decimal-point character unconditionally in generated floating-point output.
const fmtflags | showpos
| Generates a + sign in non-negative generated numeric output.
const fmtflags | skipws
| Skips leading white space before certain input operations.
const fmtflags | unitbuf
| Flushes output after each output operation.
const fmtflags | uppercase
| Replaces certain lowercase letters with their uppercase equivalents in generated output.
const fmtflags | adjustfield
| A mask of left|right|internal. Useful for the 2-arg form of `setf`.
const fmtflags | basefield
| A mask of dec|oct|hex. Useful for the 2-arg form of `setf`.
const fmtflags | floatfield
| A mask of scientific|fixed. Useful for the 2-arg form of `setf`.
const iostate | badbit
| Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).
const iostate | eofbit
| Indicates that an input operation reached the end of an input sequence.
const iostate | failbit
| Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.
const iostate | goodbit
| Indicates all is well.
const openmode | app
| Seek to end before each write.
const openmode | ate
| Open and seek to end immediately after opening.
const openmode | binary
| Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#3 and http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more.
const openmode | in
| Open for input. Default for `ifstream` and fstream.
const openmode | out
| Open for output. Default for `ofstream` and fstream.
const openmode | trunc
| Open for input. Default for `ofstream`.
const seekdir | beg
| Request a seek relative to the beginning of the stream.
const seekdir | cur
| Request a seek relative to the current position within the sequence.
const seekdir | end
| Request a seek relative to the current end of the sequence.

## Protected Member Functions

void | init (basic_streambuf< _CharT, _Traits > *__sb, __locale_cache< _CharT > *__cache=0)
| All setup is performed here.

## Detailed Description

### template<typename _CharT, typename _Traits, typename _Alloc>
class std::basic_istringstream< _CharT, _Traits, _Alloc >

Controlling input for std::string.

This class supports reading from objects of type std::basic_string, using the inherited functions from std::basic_istream. To control the associated sequence, an instance of std::basic_stringbuf is used, which this page refers to as `sb`.

Definition at line 288 of file sstream.

## Member Typedef Documentation

template<typename _CharT, typename _Traits, typename _Alloc>
typedef _CharT std::basic_istringstream< _CharT, _Traits, _Alloc >::char_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_istream< _CharT, _Traits >. Definition at line 292 of file sstream.

typedef void(* std::ios_base::event_callback)(event, ios_base&, int)`[inherited]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 357 of file ios_base.h.

typedef _Ios_Fmtflags std::ios_base::fmtflags`[inherited]`

This is a bitmask type.

`"_Ios_Fmtflags"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

- boolalpha
- dec
- fixed
- hex
- internal
- left
- oct
- right
- scientific
- showbase
- showpoint
- showpos
- skipws
- unitbuf
- uppercase
- adjustfield
- basefield
- floatfield

Definition at line 214 of file ios_base.h.

template<typename _CharT, typename _Traits, typename _Alloc>
typedef traits_type::int_type std::basic_istringstream< _CharT, _Traits, _Alloc >::int_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_istream< _CharT, _Traits >. Definition at line 298 of file sstream.

typedef _Ios_Iostate std::ios_base::iostate`[inherited]`

This is a bitmask type.

`"_Ios_Iostate"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

- badbit
- eofbit
- failbit
- goodbit

Definition at line 271 of file ios_base.h.

template<typename _CharT, typename _Traits, typename _Alloc>
typedef traits_type::off_type std::basic_istringstream< _CharT, _Traits, _Alloc >::off_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_istream< _CharT, _Traits >. Definition at line 300 of file sstream.

typedef _Ios_Openmode std::ios_base::openmode`[inherited]`

This is a bitmask type.

`"_Ios_Openmode"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

- app
- ate
- binary
- in
- out
- trunc

Definition at line 298 of file ios_base.h.

template<typename _CharT, typename _Traits, typename _Alloc>
typedef traits_type::pos_type std::basic_istringstream< _CharT, _Traits, _Alloc >::pos_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_istream< _CharT, _Traits >. Definition at line 299 of file sstream.

typedef _Ios_Seekdir std::ios_base::seekdir`[inherited]`

This is an enumerated type.

`"_Ios_Seekdir"` is implementation-defined. Defined values of type seekdir are:

- beg
- cur, equivalent to `SEEK_CUR` in the C standard library.
- end, equivalent to `SEEK_END` in the C standard library.

Definition at line 325 of file ios_base.h.

template<typename _CharT, typename _Traits, typename _Alloc>
typedef _Traits std::basic_istringstream< _CharT, _Traits, _Alloc >::traits_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_istream< _CharT, _Traits >. Definition at line 293 of file sstream.

## Member Enumeration Documentation

enum std::ios_base::event`[inherited]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 347 of file ios_base.h.

## Constructor & Destructor Documentation

template<typename _CharT, typename _Traits, typename _Alloc>
std::basic_istringstream< _CharT, _Traits, _Alloc >::basic_istringstream | ( | ios_base::openmode | __mode = ios_base::in | ) | `[inline, explicit]`

Default constructor starts with an empty string buffer.

Parameters:

  mode | Whether the buffer can read, or write, or both.

`ios_base::in` is automatically included in mode.

Initializes `sb` using `mode|in`, and passes `&sb` to the base class initializer. Does not allocate any buffer.

Definition at line 333 of file sstream.

References std::ios_base::in, and std::basic_ios< _CharT, _Traits >::init().

template<typename _CharT, typename _Traits, typename _Alloc>
std::basic_istringstream< _CharT, _Traits, _Alloc >::basic_istringstream | ( | const __string_type & | __str,
|  | ios_base::openmode | __mode = ios_base::in
| ) | `[inline, explicit]`

Starts with an existing string buffer.

Parameters:

  str | A string to copy as a starting buffer.
  mode | Whether the buffer can read, or write, or both.

`ios_base::in` is automatically included in mode.

Initializes `sb` using str and `mode|in`, and passes `&sb` to the base class initializer.

Definition at line 353 of file sstream.

References std::ios_base::in, and std::basic_ios< _CharT, _Traits >::init().

template<typename _CharT, typename _Traits, typename _Alloc>
std::basic_istringstream< _CharT, _Traits, _Alloc >::~basic_istringstream | ( |  | ) | `[inline]`

| The destructor does nothing. The buffer is deallocated by the stringbuf object, not the formatting stream. Definition at line 364 of file sstream.

## Member Function Documentation

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::bad | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if the badbit is set.

Note that other iostate flags may also be set.

Definition at line 186 of file basic_ios.h.

template<typename _CharT, typename _Traits>
void std::basic_ios< _CharT, _Traits >::clear | ( | iostate | __state = goodbit | ) | `[inherited]`

[Re]sets the error state.

Parameters:

  state | The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Definition at line 39 of file basic_ios.tcc.

References std::ios_base::badbit, std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::rdstate().

Referenced by std::basic_ios< char, _Traits >::exceptions(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< char, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_ios< _CharT, _Traits > & std::basic_ios< _CharT, _Traits >::copyfmt | ( | const basic_ios< _CharT, _Traits > & | __rhs | ) | `[inherited]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 61 of file basic_ios.tcc.

References std::ios_base::_M_callbacks, std::ios_base::_M_word, std::ios_base::_M_word_size, std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_ios< _CharT, _Traits >::fill(), std::ios_base::flags(), std::ios_base::getloc(), std::ios_base::precision(), std::basic_ios< _CharT, _Traits >::tie(), and std::ios_base::width().

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::eof | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if the eofbit is set.

Note that other iostate flags may also be set.

Definition at line 165 of file basic_ios.h.

template<typename _CharT, typename _Traits>
void std::basic_ios< _CharT, _Traits >::exceptions | ( | iostate | __except | ) | `[inline, inherited]`

Throwing exceptions on errors.

Parameters:

  except | The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flage is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

      #include <iostream>
      #include <fstream>
      #include <exception>

      int main()
      {
          std::set_terminate (__gnu_cxx::__verbose_terminate_handler);

          std::ifstream f ("/etc/motd");

          std::cerr << "Setting badbit\n";
          f.setstate (std::ios_base::badbit);

          std::cerr << "Setting exception mask\n";
          f.exceptions (std::ios_base::badbit);
      }

Definition at line 232 of file basic_ios.h.

template<typename _CharT, typename _Traits>
iostate std::basic_ios< _CharT, _Traits >::exceptions | ( |  | ) | const`[inline, inherited]`

Throwing exceptions on errors.

Returns:
  The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

Definition at line 197 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::clear(), std::basic_ios< _CharT, _Traits >::copyfmt(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::peek(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::sync(), and std::basic_istream< _CharT, _Traits >::unget().

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::fail | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

Definition at line 176 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::operator void *(), std::basic_ios< char, _Traits >::operator!(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::tellg(), and std::basic_ostream< _CharT, _Traits >::tellp().

template<typename _CharT, typename _Traits>
char_type std::basic_ios< _CharT, _Traits >::fill | ( | char_type | __ch | ) | `[inline, inherited]`

Sets a new "empty" character.

Parameters:

  ch | The new character.

Returns:
  The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

Definition at line 348 of file basic_ios.h.

template<typename _CharT, typename _Traits>
char_type std::basic_ios< _CharT, _Traits >::fill | ( |  | ) | const`[inline, inherited]`

Retreives the "empty" character.

Returns:
  The current fill character.

It defaults to a space (' ') in the current locale.

Definition at line 328 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::basic_ios< char, _Traits >::fill(), std::operator<<(), and std::basic_ostream< _CharT, _Traits >::operator<<().

fmtflags std::ios_base::flags | ( | fmtflags | __fmtfl | ) | `[inline, inherited]`

Setting new format flags all at once.

Parameters:

  fmtfl | The new flags to set.

Returns:
  The previous format control flags.

This function overwrites all the format flags with fmtfl.

Definition at line 484 of file ios_base.h.

fmtflags std::ios_base::flags | ( |  | ) | const`[inline, inherited]`

Access to format flags.

Returns:
  The format control flags for both input and output.

Definition at line 474 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_ostream< char >::operator<<(), std::basic_istream< _CharT, _Traits >::sentry::sentry(), and std::basic_ostream< _CharT, _Traits >::sentry::~sentry().

template<typename _CharT, typename _Traits>
streamsize std::basic_istream< _CharT, _Traits >::gcount | ( |  | ) | const`[inline, inherited]`

Character counting.

Returns:
  The number of characters extracted by the previous unformatted input function dispatched for this stream.

Definition at line 243 of file istream.

template<typename _CharT, typename _Traits>
__istream_type& std::basic_istream< _CharT, _Traits >::get | ( | __streambuf_type & | __sb | ) | `[inline, inherited]`

Extraction into another streambuf.

Parameters:

  sb | A streambuf in which to store data.

Returns:
  *this

Returns `get`(sb,widen('
')).

Definition at line 360 of file istream.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | __streambuf_type & | __sb,
|  | char_type | __delim
| ) | `[inherited]`

Extraction into another streambuf.

Parameters:

  sb | A streambuf in which to store data.
  delim | A "stop" character.

Returns:
  *this

Characters are extracted and inserted into sb until one of the following happens:

- the input sequence reaches EOF
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted)
- the next character equals delim (in this case, the character is not extracted)
- an exception occurs (and in this case is caught)

If no characters are stored, failbit is set in the stream's error state.

Definition at line 621 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::char_type, std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::int_type, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
__istream_type& std::basic_istream< _CharT, _Traits >::get | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inline, inherited]`

Simple multiple-character extraction.

Parameters:

  s | Pointer to an array.
  n | Maximum number of characters to store in s.

Returns:
  *this

Returns `get`(s,n,widen('
')).

Definition at line 327 of file istream.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | char_type * | __s,
|  | streamsize | __n,
|  | char_type | __delim
| ) | `[inherited]`

Simple multiple-character extraction.

Parameters:

  s | Pointer to an array.
  n | Maximum number of characters to store in s.
  delim | A "stop" character.

Returns:
  *this

Characters are extracted and stored into s until one of the following happens:

- `n-1` characters are stored
- the input sequence reaches EOF
- the next character equals delim, in which case the character is not extracted

If no characters are stored, failbit is set in the stream's error state.

In any case, a null character is stored into the next location in the array.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 579 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::char_type, std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::int_type, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | char_type & | __c | ) | `[inherited]`

Simple extraction.

Parameters:

  c | The character in which to store data.

Returns:
  *this

Tries to extract a character and store it in c. If none are available, sets failbit and returns traits::eof().

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 545 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::int_type, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::get | ( |  | ) | `[inherited]`

Simple extraction.

Returns:
  A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

Definition at line 513 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::int_type, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

Referenced by std::basic_istream< char >::get(), and std::operator>>().

template<typename _CharT, typename _Traits>
__istream_type& std::basic_istream< _CharT, _Traits >::getline | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inline, inherited]`

String extraction.

Parameters:

  s | A character array in which to store the data.
  n | Maximum number of characters to extract.

Returns:
  *this

Returns `getline`(s,n,widen('
')).

Definition at line 400 of file istream.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::getline | ( | char_type * | __s,
|  | streamsize | __n,
|  | char_type | __delim
| ) | `[inherited]`

String extraction.

Parameters:

  s | A character array in which to store the data.
  n | Maximum number of characters to extract.
  delim | A "stop" character.

Returns:
  *this

Extracts and stores characters into s until one of the following happens. Note that these criteria are required to be tested in the order listed here, to allow an input line to exactly fill the s array without setting failbit.

1. the input sequence reaches end-of-file, in which case eofbit is set in the stream error state
2. the next character equals `delim`, in which case the character is extracted (and therefore counted in `gcount()`) but not stored
3. `n-1` characters are stored, in which case failbit is set in the stream error state

If no characters are extracted, failbit is set. (An empty line of input should therefore not cause failbit to be set.)

In any case, a null character is stored in the next location in the array.

Definition at line 663 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::char_type, std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::int_type, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

Referenced by std::basic_istream< char >::getline().

locale std::ios_base::getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  The locale currently in effect.

If `imbue(loc)` has previously been called, then this function returns `loc`. Otherwise, it returns a copy of `std::locale()`, the global C++ locale.

Definition at line 616 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::operator>>(), and std::ws().

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::good | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if no error flags are set.

A wrapper around rdstate.

Definition at line 155 of file basic_ios.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore | ( | streamsize | __n = 1,
|  | int_type | __delim = traits_type::eof()
| ) | `[inherited]`

Discarding characters.

Parameters:

  n | Number of characters to discard.
  delim | A "stop" character.

Returns:
  *this

Extracts characters and throws them away until one of the following happens:

- if n `!=` `std::numeric_limits<int>::max()`, n characters are extracted
- the input sequence reaches end-of-file
- the next character equals delim (in this case, the character is extracted); note that this condition will never occur if delim equals `traits::eof()`.

Definition at line 715 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::int_type, std::max(), std::min(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
locale std::basic_ios< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) | `[inherited]`

Moves to a new locale.

Parameters:

  loc | The new locale.

Returns:
  The previous locale.

Calls `ios_base::imbue(loc)`, and if a stream buffer is associated with this stream, calls that buffer's `pubimbue(loc)`.

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Reimplemented from std::ios_base.

Definition at line 135 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::rdbuf().

template<typename _CharT, typename _Traits>
void std::basic_ios< _CharT, _Traits >::init | ( | basic_streambuf< _CharT, _Traits > * | __sb,
|  | __locale_cache< _CharT > * | __cache = 0
| ) | `[protected, inherited]`

All setup is performed here.

This is called from the public constructor. It is not virtual and cannot be redefined. The second argument, __cache, is used to initialize the standard streams without allocating memory.

Definition at line 147 of file basic_ios.tcc.

References std::ios_base::badbit, and std::ios_base::goodbit.

Referenced by std::basic_fstream< _CharT, _Traits >::basic_fstream(), std::basic_ifstream< _CharT, _Traits >::basic_ifstream(), std::basic_ios< char, _Traits >::basic_ios(), std::basic_istream< char >::basic_istream(), std::basic_istringstream< _CharT, _Traits, _Alloc >::basic_istringstream(), std::basic_ofstream< _CharT, _Traits >::basic_ofstream(), std::basic_ostream< char >::basic_ostream(), std::basic_ostringstream< _CharT, _Traits, _Alloc >::basic_ostringstream(), and std::basic_stringstream< _CharT, _Traits, _Alloc >::basic_stringstream().

long& std::ios_base::iword | ( | int | __ix | ) | `[inline, inherited]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 629 of file ios_base.h.

template<typename _CharT, typename _Traits>
char std::basic_ios< _CharT, _Traits >::narrow | ( | char_type | __c,
|  | char | __dfault
| ) | const`[inherited]`

Squeezes characters.

Parameters:

  c | The character to narrow.
  dfault | The character to narrow.

Returns:
  The narrowed character.

Maps a character of `char_type` to a character of `char`, if possible.

Returns the result of

        std::use_facet< ctype<char_type> >(getloc()).narrow(c,dfault)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 114 of file basic_ios.tcc.

Referenced by std::operator>>().

template<typename _CharT, typename _Traits>
std::basic_ios< _CharT, _Traits >::operator void * | ( |  | ) | const`[inline, inherited]`

| The quick-and-easy status check. This allows you to write constructs such as "if (!a_stream) ..." and "while (a_stream) ..." Definition at line 109 of file basic_ios.h.

template<typename _CharT, typename _Traits>
bool std::basic_ios< _CharT, _Traits >::operator! | ( |  | ) | const`[inline, inherited]`

| The quick-and-easy status check. This allows you to write constructs such as "if (!a_stream) ..." and "while (a_stream) ..." Definition at line 113 of file basic_ios.h.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | __streambuf_type * | __sb | ) | `[inherited]`

Extracting into another streambuf.

Parameters:

  sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry onject and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 482 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | void *& | __p | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 455 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | long double & | __f | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 428 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | double & | __f | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 401 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | float & | __f | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 374 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned long long & | __n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 346 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | long long & | __n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 319 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned long & | __n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 291 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | long & | __n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 264 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned int & | __n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 237 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | int & | __n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 200 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned short & | __n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 173 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | short & | __n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 136 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | bool & | __n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 109 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | ios_base &(* | __pf)(ios_base &) | ) | `[inherited]`

| Interface for manipulators. Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header. Definition at line 100 of file istream.tcc.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | __ios_type &(* | __pf)(__ios_type &) | ) | `[inherited]`

| Interface for manipulators. Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header. Definition at line 91 of file istream.tcc.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | __istream_type &(* | __pf)(__istream_type &) | ) | `[inherited]`

| Interface for manipulators. Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header. Definition at line 82 of file istream.tcc.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::peek | ( |  | ) | `[inherited]`

Looking ahead in the stream.

Returns:
  The next character, or eof().

If, after constructing the sentry object, `good()` is false, returns `traits::eof()`. Otherwise reads but does not extract the next input character.

Definition at line 753 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::int_type, and std::basic_ios< _CharT, _Traits >::rdbuf().

streamsize std::ios_base::precision | ( | streamsize | __prec | ) | `[inline, inherited]`

Changing flags.

Parameters:

  prec | The new precision value.

Returns:
  The previous value of precision().

Definition at line 552 of file ios_base.h.

streamsize std::ios_base::precision | ( |  | ) | const`[inline, inherited]`

Flags access.

Returns:
  The precision to generate on certain output operations.

Definition at line 544 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::putback | ( | char_type | __c | ) | `[inherited]`

Unextracting a single character.

Parameters:

  c | The character to push back into the input stream.

Returns:
  *this

If `rdbuf()` is not null, calls `rdbuf()->sputbackc(c)`.

If `rdbuf()` is null or if `sputbackc()` fails, sets badbit in the error state.

Note:
  Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 842 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::int_type, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

void*& std::ios_base::pword | ( | int | __ix | ) | `[inline, inherited]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 640 of file ios_base.h.

template<typename _CharT, typename _Traits>
basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) | `[inherited]`

Changing the underlying buffer.

Parameters:

  sb | The new stream buffer.

Returns:
  The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument `rdbuf()`, which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class.

Definition at line 51 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::clear().

template<typename _CharT, typename _Traits, typename _Alloc>
__stringbuf_type* std::basic_istringstream< _CharT, _Traits, _Alloc >::rdbuf | ( |  | ) | const`[inline]`

Accessing the underlying buffer.

Returns:
  The current basic_stringbuf buffer.

This hides both signatures of std::basic_ios::rdbuf().

Reimplemented from std::basic_ios< _CharT, _Traits >.

Definition at line 375 of file sstream.

template<typename _CharT, typename _Traits>
iostate std::basic_ios< _CharT, _Traits >::rdstate | ( |  | ) | const`[inline, inherited]`

Returns the error state of the stream buffer.

Returns:
  A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Definition at line 125 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::bad(), std::basic_ios< _CharT, _Traits >::clear(), std::basic_ios< char, _Traits >::eof(), std::basic_ios< char, _Traits >::fail(), and std::basic_ios< char, _Traits >::good().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::read | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inherited]`

Extraction without delimiters.

Parameters:

  s | A character array.
  n | Maximum number of characters to store.

Returns:
  *this

If the stream state is `good()`, extracts characters and stores them into s until one of the following happens:

- n characters are stored
- the input sequence reaches end-of-file, in which case the error state is set to `failbit|eofbit`.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 777 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
streamsize std::basic_istream< _CharT, _Traits >::readsome | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inherited]`

Extraction until the buffer is exhausted, but no more.

Parameters:

  s | A character array.
  n | Maximum number of characters to store.

Returns:
  The number of characters extracted.

Extracts characters and stores them into s depending on the number of characters remaining in the streambuf's buffer, `rdbuf()->in_avail()`, called `A` here:

- if `A` `==` `-1`, sets eofbit and extracts no characters
- if `A` `==` `0`, extracts no characters
- if `A` `>` `0`, extracts `min(A,n)`

The goal is to empty the current buffer, and to not request any more from the external input sequence controlled by the streambuf.

Definition at line 806 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::min(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

void std::ios_base::register_callback | ( | event_callback | __fn,
|  | int | __index
| ) | `[inherited]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 341 of file ios.cc.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg | ( | off_type | ,
|  | ios_base::seekdir |
| ) | `[inherited]`

Changing the current read position.

Parameters:

  off | A file offset object.
  dir | The direction in which to seek.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekoff(off,dir)`. If that function fails, sets failbit.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 976 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::fail(), std::basic_istream< _CharT, _Traits >::off_type, std::basic_istream< _CharT, _Traits >::pos_type, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg | ( | pos_type |  | ) | `[inherited]`

Changing the current read position.

Parameters:

  pos | A file position object.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekpos(pos)`. If that function fails, sets failbit.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 956 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::fail(), std::basic_istream< _CharT, _Traits >::off_type, std::basic_istream< _CharT, _Traits >::pos_type, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl,
|  | fmtflags | __mask
| ) | `[inline, inherited]`

Setting new format flags.

Parameters:

  fmtfl | Additional flags to set.
  mask | The flags mask for fmtfl.

Returns:
  The previous format control flags.

This function clears mask in the format flags, then sets fmtfl `&` mask. An example mask is `ios_base::adjustfield`.

Definition at line 517 of file ios_base.h.

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl | ) | `[inline, inherited]`

Setting new format flags.

Parameters:

  fmtfl | Additional flags to set.

Returns:
  The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 500 of file ios_base.h.

Referenced by std::boolalpha(), std::dec(), std::fixed(), std::hex(), std::internal(), std::left(), std::oct(), std::right(), std::scientific(), std::showbase(), std::showpoint(), std::showpos(), std::skipws(), std::unitbuf(), and std::uppercase().

template<typename _CharT, typename _Traits>
void std::basic_ios< _CharT, _Traits >::setstate | ( | iostate | __state | ) | `[inline, inherited]`

Sets additional flags in the error state.

Parameters:

  state | The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

Definition at line 145 of file basic_ios.h.

Referenced by std::basic_fstream< _CharT, _Traits >::close(), std::basic_ofstream< _CharT, _Traits >::close(), std::basic_ifstream< _CharT, _Traits >::close(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_fstream< _CharT, _Traits >::open(), std::basic_ofstream< _CharT, _Traits >::open(), std::basic_ifstream< _CharT, _Traits >::open(), std::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::read(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::unget(), std::ws(), and std::basic_ostream< _CharT, _Traits >::sentry::~sentry().

template<typename _CharT, typename _Traits, typename _Alloc>
void std::basic_istringstream< _CharT, _Traits, _Alloc >::str | ( | const __string_type & | __s | ) | `[inline]`

Setting a new buffer.

Parameters:

  s | The string to use as a new sequence.

Calls `rdbuf()->str(s)`.

Definition at line 393 of file sstream.

template<typename _CharT, typename _Traits, typename _Alloc>
__string_type std::basic_istringstream< _CharT, _Traits, _Alloc >::str | ( |  | ) | const`[inline]`

Copying out the string buffer.

Returns:
  `rdbuf()->str()`

Definition at line 383 of file sstream.

template<typename _CharT, typename _Traits>
int std::basic_istream< _CharT, _Traits >::sync | ( |  | ) | `[inherited]`

Synchronizing the stream buffer.

Returns:
  0 on success, -1 on failure

If `rdbuf()` is a null pointer, returns -1.

Otherwise, calls `rdbuf()->pubsync()`, and if that returns -1, sets badbit and returns -1.

Otherwise, returns 0.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 910 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

bool std::ios_base::sync_with_stdio | ( | bool | __sync = true | ) | `[static, inherited]`

Interaction with the standard C I/O objects.

Parameters:

  sync | Whether to synchronize or not.

Returns:
  True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#8 for more.

Definition at line 372 of file ios.cc.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits >::pos_type std::basic_istream< _CharT, _Traits >::tellg | ( |  | ) | `[inherited]`

Getting the current read position.

Returns:
  A file position object.

If `fail()` is not false, returns `pos_type`(-1) to indicate failure. Otherwise returns `rdbuf()->pubseekoff(0,cur,in)`.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 943 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::fail(), std::basic_istream< _CharT, _Traits >::pos_type, and std::basic_ios< _CharT, _Traits >::rdbuf().

template<typename _CharT, typename _Traits>
basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie | ( | basic_ostream< _CharT, _Traits > * | __tiestr | ) | `[inline, inherited]`

Ties this stream to an output stream.

Parameters:

  tiestr | The output stream.

Returns:
  The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

Definition at line 280 of file basic_ios.h.

template<typename _CharT, typename _Traits>
basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie | ( |  | ) | const`[inline, inherited]`

Fetches the current tied stream.

Returns:
  A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, `std::cin` is tied to `std::cout`.

Definition at line 268 of file basic_ios.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), and std::basic_istream< _CharT, _Traits >::sentry::sentry().

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::unget | ( |  | ) | `[inherited]`

Unextracting the previous character.

Returns:
  *this

If `rdbuf()` is not null, calls `rdbuf()->sungetc(c)`.

If `rdbuf()` is null or if `sungetc()` fails, sets badbit in the error state.

Note:
  Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 876 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions(), std::basic_istream< _CharT, _Traits >::int_type, std::basic_ios< _CharT, _Traits >::rdbuf(), and std::basic_ios< _CharT, _Traits >::setstate().

void std::ios_base::unsetf | ( | fmtflags | __mask | ) | `[inline, inherited]`

Clearing format flags.

Parameters:

  mask | The flags to unset.

This function clears mask in the format flags.

Definition at line 532 of file ios_base.h.

Referenced by std::noboolalpha(), std::noshowbase(), std::noshowpoint(), std::noshowpos(), std::noskipws(), std::nounitbuf(), and std::nouppercase().

template<typename _CharT, typename _Traits>
_CharT std::basic_ios< _CharT, _Traits >::widen | ( | char | __c | ) | const`[inherited]`

Widens characters.

Parameters:

  c | The character to widen.

Returns:
  The widened character.

Maps a character of `char` to a character of `char_type`.

Returns the result of

        std::use_facet< ctype<char_type> >(getloc()).widen(c)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 124 of file basic_ios.tcc.

References std::basic_ios< _CharT, _Traits >::char_type.

Referenced by std::endl(), std::basic_ios< char, _Traits >::fill(), and std::operator<<().

streamsize std::ios_base::width | ( | streamsize | __wide | ) | `[inline, inherited]`

Changing flags.

Parameters:

  wide | The new width value.

Returns:
  The previous value of width().

Definition at line 574 of file ios_base.h.

streamsize std::ios_base::width | ( |  | ) | const`[inline, inherited]`

Flags access.

Returns:
  The minimum field width to generate on output operations.

"Minimum field width" refers to the number of characters.

Definition at line 566 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::operator<<(), and std::operator>>().

int std::ios_base::xalloc | ( |  | ) | throw ()`[static, inherited]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 249 of file ios.cc.

## Member Data Documentation

const ios_base::fmtflags std::ios_base::adjustfield`[static, inherited]`

| A mask of left|right|internal. Useful for the 2-arg form of `setf`. Definition at line 130 of file ios.cc.

const ios_base::openmode std::ios_base::app`[static, inherited]`

| Seek to end before each write. Definition at line 139 of file ios.cc.

const ios_base::openmode std::ios_base::ate`[static, inherited]`

| Open and seek to end immediately after opening. Definition at line 140 of file ios.cc.

const ios_base::iostate std::ios_base::badbit`[static, inherited]`

| Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file). Definition at line 134 of file ios.cc. Referenced by std::basic_ios< char, _Traits >::bad(), std::basic_ios< _CharT, _Traits >::clear(), std::basic_ios< char, _Traits >::fail(), and std::basic_ios< _CharT, _Traits >::init().

const ios_base::fmtflags std::ios_base::basefield`[static, inherited]`

| A mask of dec|oct|hex. Useful for the 2-arg form of `setf`. Definition at line 131 of file ios.cc.

const ios_base::seekdir std::ios_base::beg`[static, inherited]`

| Request a seek relative to the beginning of the stream. Definition at line 146 of file ios.cc.

const ios_base::openmode std::ios_base::binary`[static, inherited]`

| Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#3 and http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more. Definition at line 141 of file ios.cc.

const ios_base::fmtflags std::ios_base::boolalpha`[static, inherited]`

| Insert/extract `bool` in alphabetic rather than numeric format. Definition at line 115 of file ios.cc.

const ios_base::seekdir std::ios_base::cur`[static, inherited]`

| Request a seek relative to the current position within the sequence. Definition at line 147 of file ios.cc.

const ios_base::fmtflags std::ios_base::dec`[static, inherited]`

| Converts integer input or generates integer output in decimal base. Definition at line 116 of file ios.cc.

const ios_base::seekdir std::ios_base::end`[static, inherited]`

| Request a seek relative to the current end of the sequence. Definition at line 148 of file ios.cc.

const ios_base::iostate std::ios_base::eofbit`[static, inherited]`

| Indicates that an input operation reached the end of an input sequence. Definition at line 135 of file ios.cc. Referenced by std::basic_ios< char, _Traits >::eof().

const ios_base::iostate std::ios_base::failbit`[static, inherited]`

| Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters. Definition at line 136 of file ios.cc. Referenced by std::basic_ios< char, _Traits >::fail().

const ios_base::fmtflags std::ios_base::fixed`[static, inherited]`

| Generate floating-point output in fixed-point notation. Definition at line 117 of file ios.cc.

const ios_base::fmtflags std::ios_base::floatfield`[static, inherited]`

| A mask of scientific|fixed. Useful for the 2-arg form of `setf`. Definition at line 132 of file ios.cc.

const ios_base::iostate std::ios_base::goodbit`[static, inherited]`

| Indicates all is well. Definition at line 137 of file ios.cc. Referenced by std::basic_ios< _CharT, _Traits >::init().

const ios_base::fmtflags std::ios_base::hex`[static, inherited]`

| Converts integer input or generates integer output in hexadecimal base. Definition at line 118 of file ios.cc.

const ios_base::openmode std::ios_base::in`[static, inherited]`

| Open for input. Default for `ifstream` and fstream. Definition at line 142 of file ios.cc. Referenced by std::basic_istringstream< _CharT, _Traits, _Alloc >::basic_istringstream().

const ios_base::fmtflags std::ios_base::internal`[static, inherited]`

| Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated. Definition at line 119 of file ios.cc.

const ios_base::fmtflags std::ios_base::left`[static, inherited]`

| Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.). Definition at line 120 of file ios.cc.

const ios_base::fmtflags std::ios_base::oct`[static, inherited]`

| Converts integer input or generates integer output in octal base. Definition at line 121 of file ios.cc.

const ios_base::openmode std::ios_base::out`[static, inherited]`

| Open for output. Default for `ofstream` and fstream. Definition at line 143 of file ios.cc. Referenced by std::basic_ostringstream< _CharT, _Traits, _Alloc >::basic_ostringstream().

const ios_base::fmtflags std::ios_base::right`[static, inherited]`

| Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.). Definition at line 122 of file ios.cc.

const ios_base::fmtflags std::ios_base::scientific`[static, inherited]`

| Generates floating-point output in scientific notation. Definition at line 123 of file ios.cc.

const ios_base::fmtflags std::ios_base::showbase`[static, inherited]`

| Generates a prefix indicating the numeric base of generated integer output. Definition at line 124 of file ios.cc.

const ios_base::fmtflags std::ios_base::showpoint`[static, inherited]`

| Generates a decimal-point character unconditionally in generated floating-point output. Definition at line 125 of file ios.cc.

const ios_base::fmtflags std::ios_base::showpos`[static, inherited]`

| Generates a + sign in non-negative generated numeric output. Definition at line 126 of file ios.cc.

const ios_base::fmtflags std::ios_base::skipws`[static, inherited]`

| Skips leading white space before certain input operations. Definition at line 127 of file ios.cc.

const ios_base::openmode std::ios_base::trunc`[static, inherited]`

| Open for input. Default for `ofstream`. Definition at line 144 of file ios.cc.

const ios_base::fmtflags std::ios_base::unitbuf`[static, inherited]`

| Flushes output after each output operation. Definition at line 128 of file ios.cc.

const ios_base::fmtflags std::ios_base::uppercase`[static, inherited]`

| Replaces certain lowercase letters with their uppercase equivalents in generated output. Definition at line 129 of file ios.cc.

The documentation for this class was generated from the following file:

- sstream